
//image variables, one is the pointer part of the knob and the other is the backgroud
PImage knobhandle;
PImage bg;

//Large image to hold all our frames
PImage GRANDE;

//the start and stop angles of the knob
float StartAngle = 40;
float StopAngle = 360-StartAngle;

//how many frames we want, remember that if you are using this for a VST-GUI you're limiting the resolution of the parameter by setti
g this to something low
float NumberOfFrames = 10;

//working variables
float myFrameCount =0;
int grandecounter =0;
float angle = StartAngle;

//how much rotation we should do between each frame
float delta = (StopAngle-StartAngle)/(NumberOfFrames-1);

void setup() 
{
  //loading the images
  knobhandle = loadImage("handle.png");
  bg = loadImage("bgg-red.png");
  //setting the size of the window to the same size as our background image
  size(bg.width,bg.height);  

  //creating a large image to keep all our frames
  GRANDE = createImage(bg.width, (int)(bg.height*NumberOfFrames), ARGB);

}

void draw() 
{ 

  //conversion of the angle to radians, since the rotate function wants that
  float radang=radians(angle);

  //painting the background image
  image(bg, (width/2)-(bg.width/2) ,(height/2)-(bg.height/2));

  pushMatrix(); //cant really explain this on one line, has to do with how you draw in the cordinate system.
  translate(width/2, height/2); //sets everything we draw to be centerd
  rotate(radang); //rotates our stuff
  image(knobhandle, -knobhandle.width/2 ,-knobhandle.height/2);//drawing the handle
  popMatrix(); //se above comment on pushMatrix

    angle = angle + delta; // increasing the angle

  if(  myFrameCount >= NumberOfFrames)
    delta =0;

  myFrameCount++;
  if(delta==0) //if we are done we set delta to 0 to be able to call noLoop and stop executing
  {
    GRANDE.save("0000000aaaaaaaaa.png"  ); //saving the frames we've collected to a png file 
    //this will not take place until next loop, so we will have one visible frame more then we want, this is not saved though, so no worr
    es
      noLoop(); 
  }
  else if(delta!=0)
  {
    for (int lw=0;lw<bg.width;lw++)
    {
      for (int lh=0;lh<bg.height;lh++)
      {
        GRANDE.pixels[grandecounter]= this.get(lh,lw); //here we get the pixels in the current frame and adds them to our GRANDE pixelbuffer
        grandecounter++;
      }
    }
  }

}





